#ifndef __CONFIG_H
#define __CONFIG_H

#ifndef __linux__
#error "iplog compiles on Linux -ONLY-"
#endif

/* This is the main configuration file.  If you can't figure this out, die. */

/* GENERAL STUFF */

	/* Log to write to (if undefined, use syslog(3) <-- DEFAULT)
	   %s is replaced by the program's name */

//#define LOGFILE   "/var/log/%s"


	/* Logging facility */
#define LOGGING_FACILITY	LOG_DAEMON

	/* Logging options (man 3 syslog) */
#define LOGGING_OPTIONS     LOG_NDELAY

   /* Logging priority */
#define LOGGING_PRIORITY    LOG_NOTICE

   /* Log smurf attacks */
#define DETECT_SMURF

/* TCPLOG (comment out to negate) */

	/* Log "null" scans -- used by port scanners like nmap */
#define DETECT_NULL

	/* Log "fin" scans -- used by port scanners like nmap */
#define DETECT_FIN

	/* Log bogus tcp flags -- set by some host identifiers (queso, nmap) */
#define DETECT_BOGUS

	/* Log http connections -- logs get messy on a web site */
#define LOG_HTTP_CONNECTS

	/* Log ftp transfers -- might make logs messy on a ftp site! */
#define LOG_FTP_TRANSFERS

	/* Get name of connecting user (if port is listening) */
#define	RETRIEVE_IDENTD

	/* Detect port scans and avoid logging more than is neccesary */
#define USE_PORTSCAN_DETECTION

	/* Cache resolved hostnames (speeds up repetitive resolves) */
#define USE_DNS_CACHE

/* UDPLOG (comment out to negate) */

	/* Log uses of traceroute(1) -- clarifies connections to weird ports */

#define DETECT_TRACEROUTE

	/* Ignore stuff from the nfs port (if you use NFS, define this) */
//#define IGNORE_NFS

#endif /* __CONFIG_H */
