/* ident.c of iplog v1.8 -- eric@ojnk.org */
#include "config.h"
#ifdef RETRIEVE_IDENTD
#include "common.h"
#include "ident.h"

char *get_identd_data(struct tcp_header *hdr)
{
	fd_set fd_read;
	int s, on = 1;
	struct timeval tv;
	struct sockaddr_in sin;
	static char *user = NULL;
	char buf[512], temp[64];

	if ((s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) != -1) {
		(void)setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));

		sin.sin_family = AF_INET;
		sin.sin_addr = hdr->ip.ip_dst;
		sin.sin_port = INADDR_ANY;

		if (bind(s, (struct sockaddr *)&sin, sizeof(sin)) != -1) {
			sin.sin_family = AF_INET;
			sin.sin_port = IDENTD_PORT;
			sin.sin_addr = hdr->ip.ip_src;

			if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) != -1) {
				snprintf(buf, sizeof(buf), "%u , %u\r\n", UNFIX(hdr->tcp.th_sport), UNFIX(hdr->tcp.th_dport));
				send(s, buf, strlen(buf), 0);
				memset(buf, 0, sizeof(buf));

				tv.tv_sec = 10;
				tv.tv_usec = 0;

				FD_ZERO(&fd_read);
				FD_SET(s, &fd_read);

				if (select(s + 1, &fd_read, NULL, NULL, &tv) > 0)
					if (recv(s, buf, 512, 0) > 0)
						if (sscanf(buf, IDENTD_FORMAT, temp) > 0)
							user = strdup(temp);

			}
		}
		(void)close(s);
	}
	return (user);
}

int l_port(u_short port)
{
	FILE *fp;
	unsigned int lport, mode;
	char buf[BUFSIZ];

	if ((fp = fopen(TCP_DATA, "r")) == NULL)
		return 0;

	while (fgets(buf, sizeof(buf) - 1, fp) != NULL)
		if ((sscanf(buf, TCP_FORMAT, &lport, &mode) == 2) && (UNFIX(lport) == port) && (mode == TCP_LISTEN))
			break;

	(void)fclose(fp);

	return (UNFIX(lport) == port && mode == TCP_LISTEN);
}

#endif /* RETRIEVE_IDENTD */
