/* iplog.h of iplog v1.8 -- eric@ojnk.org */
#ifndef __IPLOG_H
#define __IPLOG_H

#ifdef LOGFILE
void openlog(const char *, int, int);
void syslog(int, const char *fmt,...);

#endif

#ifndef DROP_USER
#define DROP_USER "nobody"
#endif

#ifndef DROP_GROUP
#define DROP_GROUP "nogroup"
#endif

#ifndef LOGGING_OPTIONS
#define LOGGING_OPTIONS  LOG_NDELAY
#endif

#ifndef LOGGING_FACILITY
#define LOGGING_FACILITY LOG_DAEMON
#endif

#ifndef LOGGING_PRIORITY
#define LOGGING_PRIORITY LOG_NOTICE
#endif

#ifndef LEVEL
#define LEVEL    LOGGING_PRIORITY
#endif

int comp(const void *a, const void *b);
char *service_lookup(u_short port, const char *proto);
u_short network_byte_ordering(u_short x);
void fatal(const char *fmt,...);
void fork_to_background(void);
void assert_id(uid_t uid, gid_t gid);
void drop_privileges(void);
char *my_getpid(void);
void initialize_lockfile(char *p);


#endif /* __IPLOG_H */
